/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.31 from the
 * contents of linux.xs. Do not edit this file, edit linux.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "linux.xs"
#include <EXTERN.h>
#include <perl.h>
#include <XSUB.h>

#define ALSA_PCM_NEW_HW_PARAMS_API
#define ALSA_PCM_NEW_SW_PARAMS_API
#include <alsa/asoundlib.h>

/* Nested dynamic loaded extension magic ... */
#include "../../Data/Audio.m"
AudioVtab     *AudioVptr;

#define SAMP_RATE 11025

#if 0
const char *pcm_name = "plughw:0,0";
#else
const char *pcm_name = "default";
#endif

static const char *
audio_statestr(snd_pcm_state_t state)
{
 switch(state)
  {
   case SND_PCM_STATE_OPEN:	return "open";
   case SND_PCM_STATE_SETUP:	return "setup";
   case SND_PCM_STATE_PREPARED:	return "prepared";
   case SND_PCM_STATE_RUNNING:	return "running";
   case SND_PCM_STATE_XRUN:	return "xrun";
   case SND_PCM_STATE_DRAINING:	return "draining";
   case SND_PCM_STATE_PAUSED:	return "paused";
   case SND_PCM_STATE_SUSPENDED:return "suspended";
   default:			return "unknown";
  }
}

typedef struct
{
 unsigned int samp_rate;
 snd_pcm_t *pcm;
 snd_pcm_hw_params_t *hwparams;
 float gain;
 snd_pcm_uframes_t chunk;
} play_audio_t;

static int
audio_prepare(play_audio_t *dev)
{
 if (dev)
  {
   int err;
   int dir = 0;
   unsigned int rate = dev->samp_rate;
   snd_pcm_state_t state = snd_pcm_state(dev->pcm);
#if 0
   warn("%s with state %s",__FUNCTION__,audio_statestr(state));
#endif
   /* ALSA lib is fussy - won't let you reset this struct
      even if setting to same value so we need to re-get the
      uncommitted values every time
    */
   if ((err = snd_pcm_hw_params_any(dev->pcm,dev->hwparams)) < 0)
    {
     warn("Cannot read hwparams:%s",snd_strerror(err));
    }
   if ((err = snd_pcm_hw_params_set_access(dev->pcm, dev->hwparams, SND_PCM_ACCESS_RW_INTERLEAVED)) < 0)
    {
     warn("Cannot set access %s:%s",pcm_name,snd_strerror(err));
     return 0;
    }
   /* Set sample format */
   if ((err=snd_pcm_hw_params_set_format(dev->pcm, dev->hwparams, SND_PCM_FORMAT_S16)) < 0)
    {
     warn("Error setting format %s:%s",pcm_name,snd_strerror(err));
     return(0);
    }
#ifdef ALSA_PCM_NEW_HW_PARAMS_API
   err = snd_pcm_hw_params_set_rate_near(dev->pcm, dev->hwparams, &rate, &dir);
#else
   rate = snd_pcm_hw_params_set_rate_near(dev->pcm, dev->hwparams, dev->samp_rate, &dir);
#endif
   if (dir || rate != dev->samp_rate)
    {
     unsigned int num;
     unsigned int den;
     if ((err = snd_pcm_hw_params_get_rate_numden(dev->hwparams,&num,&den)) < 0)
      {
       warn("Cannot get exact rate (%s) using %d", snd_strerror(err), rate);
      }
     else
      {
       warn("Wanted %ldHz, got(%d) %ld (%u/%u=%.10gHz",dev->samp_rate,dir,
             rate,num,den,1.0*num/den);

      }
     dev->samp_rate = rate;
    }
   if ((err=snd_pcm_hw_params_set_channels(dev->pcm, dev->hwparams, 1)) < 0)
    {
     warn("Error setting channels %s:%s",pcm_name,snd_strerror(err));
     return(0);
    }
   /* Apply HW parameter settings to */
   /* PCM device and prepare device  */
   if ((err=snd_pcm_hw_params(dev->pcm, dev->hwparams)) < 0)
    {
     warn("Error setting parameters %s:%s",pcm_name,snd_strerror(err));
     return(0);
    }
#ifdef ALSA_PCM_NEW_HW_PARAMS_API
   err = snd_pcm_hw_params_get_buffer_size (dev->hwparams, &dev->chunk);
#else
   dev->chunk = snd_pcm_hw_params_get_buffer_size (dev->hwparams);
#endif
   state = snd_pcm_state(dev->pcm);
#if 0
   warn("prepared now state %s",audio_statestr(state));
#endif
   return 1;
  }
 return 0;
}


static int
audio_init(play_audio_t *dev,int wait)
{
 int err;
 if (!dev->gain)
  dev->gain = 1.0f;
 if (!dev->samp_rate)
  dev->samp_rate = SAMP_RATE;
 if ((err = snd_pcm_open(&dev->pcm,pcm_name,SND_PCM_STREAM_PLAYBACK,0)) < 0)
  {
   warn("Cannot open %s (%d):%s",pcm_name,wait,snd_strerror(err));
   return 0;
  }
 else
  {
   if ((err = snd_pcm_hw_params_malloc(&dev->hwparams)) < 0)
    {
     warn("Cannot allocate hwparams:%s",snd_strerror(err));
    }
   if ((err = snd_pcm_hw_params_any(dev->pcm,dev->hwparams)) < 0)
    {
     warn("Cannot read hwparams:%s",snd_strerror(err));
    }
   return 1;
  }
}

void
audio_flush(play_audio_t *dev)
{
 if (dev->pcm)
  {
   snd_pcm_state_t state = snd_pcm_state(dev->pcm);
   switch(state)
    {
     case SND_PCM_STATE_RUNNING:
      {
       /* Stop PCM device after pending frames have been played */
       int err = snd_pcm_drain(dev->pcm);
       if (err < 0)
        {
         warn("%s", snd_strerror(err));
        }
        break;
      }
     default:
      warn("%s with state %s",__FUNCTION__,audio_statestr(state));
      break;
    }
  }
}

static void
audio_close(play_audio_t *dev)
{
 if (dev)
  {
   /* Close audio system  */
   if (dev->hwparams)
    {
     snd_pcm_hw_params_free(dev->hwparams);
     dev->hwparams = 0;
    }
   if (dev->pcm)
    {
     snd_pcm_close(dev->pcm);
     dev->pcm = 0;
    }
   dev->chunk = 0;
  }
}


UV
audio_rate(play_audio_t *dev, UV rate)
{unsigned int old = dev->samp_rate;
 if (rate && rate != dev->samp_rate)
  {
   snd_pcm_state_t state;
   int dir = 0;
   int err;
   audio_flush(dev);
   switch ((state = snd_pcm_state(dev->pcm)))
    {
     case SND_PCM_STATE_OPEN:
      break;
     case SND_PCM_STATE_SETUP:
     case SND_PCM_STATE_PREPARED:
     case SND_PCM_STATE_RUNNING:
     case SND_PCM_STATE_XRUN:
     case SND_PCM_STATE_DRAINING:
     case SND_PCM_STATE_PAUSED:
     case SND_PCM_STATE_SUSPENDED:
     default:
      audio_close(dev);
      if (!audio_init(dev,1))
       {
        croak("Cannot re-open %s");
       }
      break;
    }
#if 0
   warn("%s with state %s",__FUNCTION__,audio_statestr(state));
#endif

#ifdef ALSA_PCM_NEW_HW_PARAMS_API
   dev->samp_rate = rate;
   err = snd_pcm_hw_params_set_rate_near(dev->pcm, dev->hwparams, &dev->samp_rate, &dir);
#else
   dev->samp_rate = snd_pcm_hw_params_set_rate_near(dev->pcm, dev->hwparams, rate, &dir);
#endif
   if (dir || rate != dev->samp_rate)
    {
     unsigned int num;
     unsigned int den;
     if ((err = snd_pcm_hw_params_get_rate_numden(dev->hwparams,&num,&den)) < 0)
      {
       warn("Cannot get exact rate (%s) using %d", snd_strerror(err), dev->samp_rate);
      }
     else
      {
       warn("Wanted %ldHz, got(%d) %ld (%u/%u=%.10gHz",rate,dir,
             dev->samp_rate,num,den,1.0*num/den);

      }
    }
  }
 return old;
}

void
audio_DESTROY(play_audio_t *dev)
{
 audio_flush(dev);
 audio_close(dev);
}

void
audio_play16(play_audio_t *dev,int n, short *data)
{
 if (n > 0 && dev->pcm)
  {
   snd_pcm_sframes_t ret;
   while (n > 0)
    {
     size_t amount = ((size_t) n > dev->chunk) ? dev->chunk : (size_t) n;
     while ((ret = snd_pcm_writei(dev->pcm, data, amount)) < 0)
      {
       warn("%s:%s",pcm_name,snd_strerror(ret));
       snd_pcm_prepare(dev->pcm);
      }
     n -= ret;
     data += ret;
    }
  }
}

float
audio_gain(play_audio_t *dev,float gain)
{
 float prev_gain = dev->gain;
 if (gain >= 0.0)
  {
   if (gain != 1.0)
    warn("Cannot change audio gain yet");
  }
 return prev_gain;
}

/*
   API level Play function
    - volume may go from the interface - it is un-natural
    - convert to 'short' should be done at Audio::Play level
    - likewise rate-matching needs to be higher level
*/
void
audio_play(play_audio_t *dev, Audio *au, float volume)
{
 STRLEN samp = Audio_samples(au);
 SV *tmp = Audio_shorts(au);
 if (volume >= 0)
  audio_gain(dev, volume);

 if (au->rate != audio_rate(dev,0))
  audio_rate(dev, au->rate);           /* Or re-sample to dev's rate ??? */

 if (!dev->chunk)
  audio_prepare(dev);

 audio_play16(dev, samp, (short *) SvPVX(tmp));
 SvREFCNT_dec(tmp);
}

#line 329 "linux.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 473 "linux.c"

XS_EUPXS(XS_Audio__Play__linux_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Play__linux_new)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, wait = 1");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
	IV	wait;
	play_audio_t *	RETVAL;

	if (items < 2)
	    wait = 1;
	else {
	    wait = (IV)SvIV(ST(1))
;
	}
#line 328 "linux.xs"
 {static play_audio_t buf;
  if (!audio_init(RETVAL = &buf,wait))
   {
    XSRETURN_NO;
   }
 }
#line 500 "linux.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pvn(RETVALSV, (class) ? class : "Audio::Play::linux", (char *) RETVAL, sizeof(*RETVAL));
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Play__linux_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Play__linux_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	play_audio_t *	dev;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    dev = (play_audio_t *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*dev))
	      croak("dev is not large enough");
	}
	else
	    croak("dev is not an object")
;

	audio_DESTROY(dev);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Play__linux_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Play__linux_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	play_audio_t *	dev;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    dev = (play_audio_t *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*dev))
	      croak("dev is not large enough");
	}
	else
	    croak("dev is not an object")
;

	audio_flush(dev);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Audio__Play__linux_gain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Play__linux_gain)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dev, val = -1.0");
    {
	play_audio_t *	dev;
	double	val;
	double	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    dev = (play_audio_t *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*dev))
	      croak("dev is not large enough");
	}
	else
	    croak("dev is not an object")
;

	if (items < 2)
	    val = -1.0;
	else {
	    val = (double)SvNV(ST(1))
;
	}

	RETVAL = audio_gain(dev, val);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Play__linux_rate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Play__linux_rate)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dev, rate = 0");
    {
	play_audio_t *	dev;
	IV	rate;
	IV	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    dev = (play_audio_t *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*dev))
	      croak("dev is not large enough");
	}
	else
	    croak("dev is not an object")
;

	if (items < 2)
	    rate = 0;
	else {
	    rate = (IV)SvIV(ST(1))
;
	}

	RETVAL = audio_rate(dev, rate);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Audio__Play__linux_play); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Audio__Play__linux_play)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dev, au, vol = -1.0");
    {
	play_audio_t *	dev;
	Audio *	au;
	float	vol;

	if (sv_isobject(ST(0))) {
	    STRLEN size;
	    dev = (play_audio_t *) SvPV((SV*)SvRV(ST(0)),size);
	    if (size < sizeof(*dev))
	      croak("dev is not large enough");
	}
	else
	    croak("dev is not an object")
;

	if (sv_isobject(ST(1))) {
	    STRLEN size;
	    au = (Audio *) SvPV((SV*)SvRV(ST(1)),size);
	    if (size < sizeof(*au))
	      croak("au is not large enough");
	}
	else
	    croak("au is not an object")
;

	if (items < 3)
	    vol = -1.0;
	else {
	    vol = (float)SvNV(ST(2))
;
	}

	audio_play(dev, au, vol);
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Audio__Play__linux); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Audio__Play__linux)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Audio::Play::linux::new", XS_Audio__Play__linux_new);
        newXS_deffile("Audio::Play::linux::DESTROY", XS_Audio__Play__linux_DESTROY);
        newXS_deffile("Audio::Play::linux::flush", XS_Audio__Play__linux_flush);
        newXS_deffile("Audio::Play::linux::gain", XS_Audio__Play__linux_gain);
        newXS_deffile("Audio::Play::linux::rate", XS_Audio__Play__linux_rate);
        newXS_deffile("Audio::Play::linux::play", XS_Audio__Play__linux_play);

    /* Initialisation Section */

#line 362 "linux.xs"
 {
  /* Nested dynamic loaded extension magic ... */
  AudioVptr = (AudioVtab *) SvIV(perl_get_sv("Audio::Data::AudioVtab",5));
 }

#line 720 "linux.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

